<?php

/*
Plugin Name: WP All Import Listeo Add-On
Description: An add-on for importing Listing data to Listeo 
Version: 1.3
Author: Purethemes.net
*/


include "rapid-addon.php";

$listeo_addon = new RapidAddon('Listeo Add-On - Listing fields', 'listeo_addon');

$listeo_addon->import_images( '_gallery', 'Gallery Images' );

$listeo_addon->add_options( 
        $listeo_addon->add_field( '_address', 'Listing Address', 'text' ),
        'Location Details', 
        array(
                $listeo_addon->add_field( '_friendly_address', 'Listing Short Address', 'text' ),
                $listeo_addon->add_field( '_geolocation_lat', 'Latitude', 'text' ),
                $listeo_addon->add_field( '_geolocation_long', 'Longitude', 'text' ),
                $listeo_addon->add_field( '_place_id', 'Google Maps Place ID', 'text' ),
        )
);

$listeo_addon->add_field( '_listing_type', 'Listing Type','text');
$listeo_addon->add_field( '_verified', 'Verified Listing','radio',array(
        'on' => 'on',
        '' => 'off'
    ));
$listeo_addon->add_field( '_featured', 'Featured Listing','radio',array(
        'on' => 'on',
        '' => 'off'
    ));

$listeo_addon->add_field( '_booking_status', 'Booking Status','radio',array(
        'on' => 'on',
        '' => 'off'
    ));
$listeo_addon->add_field( '_booking_link', 'External Booking Link','text');
$listeo_addon->add_field( '_normal_price', 'Booking Price regular days','text');
$listeo_addon->add_field( '_weekday_price', 'Booking Price weekend days','text');
$listeo_addon->add_field( '_weekday_price', 'Booking Price weekend days','text');
$listeo_addon->add_field( '_event_date', 'Event start date','text');
$listeo_addon->add_field( '_event_date_end', 'Event end date','text');
$listeo_addon->add_field( '_max_guests', 'Max number of guests','text');
$listeo_addon->add_field( 'listeo-avg-rating', 'Average Listing rating','text');


$listeo_addon->add_field( '_price_min', 'Price Range - minimum','text');
$listeo_addon->add_field( '_price_max', 'Price Range - maximum','text');
$listeo_addon->add_field( '_phone', 'Phone','text');
$listeo_addon->add_field( '_email', 'Email','text');
$listeo_addon->add_field( '_email_contact_widget', 'Use it for contact widget','radio',array(
        'on' => 'on',
        '' => 'off'
    ));

$listeo_addon->add_field( '_website', 'URL','text');
$listeo_addon->add_field( '_facebook', 'Facebook','text');
$listeo_addon->add_field( '_twitter', 'Twitter','text');
$listeo_addon->add_field( '_youtube', 'YouTube','text');
$listeo_addon->add_field( '_instagram', 'Instagram','text');
$listeo_addon->add_field( '_whatsapp', 'WhatsApp','text');
$listeo_addon->add_field( '_video', 'Embedable Video link','text');	


$days = array(
'monday'	=> __('Monday','listeo_core'),
'tuesday' 	=> __('Tuesday','listeo_core'),
'wednesday' => __('Wednesday','listeo_core'),
'thursday' 	=> __('Thursday','listeo_core'),
'friday' 	=> __('Friday','listeo_core'),
'saturday' 	=> __('Saturday','listeo_core'),
'sunday' 	=> __('Sunday','listeo_core'),
);

foreach ($days as $key => $value) {
	$listeo_addon->add_field( '_'.$key.'_opening_hour', ucwords($key) . ' Opening Hour', 'text' );
	$listeo_addon->add_field( '_'.$key.'_closing_hour', ucwords($key) . ' Closing Hour', 'text' );
}


//import custom fields
if(class_exists('Listeo_Core_Meta_Boxes')){
	

	$services_details_list = Listeo_Core_Meta_Boxes::meta_boxes_service(); 
	$rental_details_list = Listeo_Core_Meta_Boxes::meta_boxes_rental(); 
	$event_details_list = Listeo_Core_Meta_Boxes::meta_boxes_event(); 
	$classifieds_details_list = Listeo_Core_Meta_Boxes::meta_boxes_classifieds(); 
}
if(isset($services_details_list['fields'])) :
foreach ($services_details_list['fields'] as $detail => $value) {
	     $listeo_addon->add_field( $value['id'], $value['name'],'text');	
}
endif;

if(isset($rental_details_list['fields'])) :
foreach ($rental_details_list['fields'] as $detail => $value) {
	     $listeo_addon->add_field( $value['id'], $value['name'],'text');	
}
endif;

if(isset($event_details_list['fields'])) :
foreach ($event_details_list['fields'] as $detail => $value) {
	     $listeo_addon->add_field( $value['id'], $value['name'],'text');	
}
endif;

if(isset($classifieds_details_list['fields'])) :
foreach ($classifieds_details_list['fields'] as $detail => $value) {
	     $listeo_addon->add_field( $value['id'], $value['name'],'text');	
}
endif;


$listeo_addon->set_import_function('listeo_addon_import');

// admin notice if WPAI and/or Yoast isn't installed

if (function_exists('is_plugin_active')) {

	
	if ( !is_plugin_active( "listeo-core/listeo-core.php" )  ) {

		// Specify a custom admin notice.
		$listeo_addon->admin_notice(
			'The WP All Import Listeo Add-On requires Listeo  Core plugin.'
		);
	}

	
	if ( is_plugin_active("listeo-core/listeo-core.php" )  ) {
		
		$listeo_addon->run( array(
				"post_types" => array( "listing" )
		) );
		
	}
}

function listeo_addon_import($post_id, $data, $import_options) {

	global $listeo_addon;

	// all fields except for slider and image fields
    $fields = array(
    	'_listing_expires',
    	'_listing_type',
    	'_opening_hours_status',
    	'_verified',
    	'_featured',
    	'_booking_status',
    	'_booking_link',
		'_slots_status',
		'_slots',
		'_event_tickets',
		'_normal_price',
		'_weekday_price',
		'_reservation_price',
		'_expired_after',
		'_count_per_guest',
		'_max_guests',
		'listeo-avg-rating',
		'_availability',
		'_address',
		'_friendly_address',
		'_geolocation_lat',
		'_geolocation_long',
		'_place_id',
		'_event_date',
		'_event_date_end',
		'_size',
		'_price_min',
		'_price_max',
		'_gallery_style',
		'_phone',
		'_email',
		'_email_contact_widget',
		'_website',
		'_facebook',
		'_twitter',
		'_youtube',
		'_instagram',
		'_whatsapp',
		'_area',
		'_rooms',
		'_bedrooms',
		'_bathrooms',
		'_area',
		'_rooms',
		'_video',
    );
	$services_details_list = Listeo_Core_Meta_Boxes::meta_boxes_service(); 
	$rental_details_list = Listeo_Core_Meta_Boxes::meta_boxes_rental(); 
	$event_details_list = Listeo_Core_Meta_Boxes::meta_boxes_event(); 
	$classifieds_details_list = Listeo_Core_Meta_Boxes::meta_boxes_classifieds(); 

if(isset($services_details_list['fields'])) :
foreach ($services_details_list['fields'] as $detail => $value) {
	     $fields[] = $value['id'];
}
endif;

if(isset($rental_details_list['fields'])) :
foreach ($rental_details_list['fields'] as $detail => $value) {
	     $fields[] = $value['id'];
}
endif;

if(isset($event_details_list['fields'])) :
foreach ($event_details_list['fields'] as $detail => $value) {
	   $fields[] = $value['id'];
}
endif;

if(isset($classifieds_details_list['fields'])) :
foreach ($classifieds_details_list['fields'] as $detail => $value) {
$fields[] = $value['id'];
}
endif;


	$days = listeo_get_days();
	foreach ($days as $key => $value) {
		$fields[] = '_'.$key.'_opening_hour';
		$fields[] = '_'.$key.'_closing_hour';
	}
// update everything in fields arrays
    foreach ( $fields as $field ) {

        if ( $listeo_addon->can_update_meta( $field, $import_options ) ) {

        	if ( strlen( $data[$field] ) == 0 ) {

        		delete_post_meta( $post_id, $field );

        	} else {
        		if(strpos($field,'hour')){
        			$array = array( $data[$field] );
        			update_post_meta( $post_id, $field,$array );		
        		} else {
        			update_post_meta( $post_id, $field, $data[$field] );		
        		}
                

            }
        }
    }



	if ($listeo_addon->can_update_image($import_options)) {
		$image_url = wp_get_attachment_url($data['yoast_wpseo_opengraph-image']['attachment_id']);
		update_post_meta($post_id, '_yoast_wpseo_opengraph-image', $image_url);
	}

}


function _gallery( $post_id, $attachment_id, $image_filepath, $import_options ) {

	$current_images = get_post_meta( $post_id, '_gallery', true );

	$images_array = array();

	if ( !empty( $current_images ) ) {

		foreach ( $current_images as $id => $url ) {
			
			$images_array[$id] = $url;

		}

	}

	$image_url = wp_get_attachment_url( $attachment_id );

	$images_array[$attachment_id] = $image_url;

    update_post_meta( $post_id, '_gallery', $images_array );
}



// GS 16/10/2018 add geocoding info using WP All Import post row processing hook (if WPAI plugin loaded)

 add_action('pmxi_saved_post', 'listeo_do_geo_after_post_saved', 10, 1);

function listeo_do_geo_after_post_saved($post_id)
{

 // init variables
 global $listeo_addon;
 $address_used=null;
 $address1 = get_post_meta($post_id, '_friendly_address', true);
 $address2 = get_post_meta($post_id, '_address', true);
 $address3 = null;
 if (($pos = strpos($address1, ',')) !== false)
 {
  $address3 = substr($address1, $pos + 1); // truncate first line of address
 }
 $key = get_option('listeo_maps_api_server' ); // google maps api key
 $request = null;

 // request geocode info and extract location from json array. Try 3 times until google returns data.
 // 1st try with friendly address.
 // 2nd try with google maps address.
 // 3rd try with the first line of the friendly address removed.
 if (!empty($address1)) {
  $address_used = 'friendly address used';
  $request = get_google_api_request_data($address1, $key);
  if (empty($request) && !empty($address2)) {
   $address_used = 'google maps address used';
   $request = get_google_api_request_data($address2, $key);
   if (empty($request) && !empty($address3)) {
    $address_used = 'truncated friendly address used';
    $request = get_google_api_request_data($address3, $key);
    if (empty($request)) {
     $address_used = 'geocoding failed!';
     $listeo_addon->log( $address_used );
    }
   }
  }
 } 
 $json=wp_remote_retrieve_body($request);
 $data=json_decode($json);
 
 // populate lat and long
 if(!empty($data)) {
  foreach($data->results as $results) {
   $latitude=$results->geometry->location->lat;
   $longitude=$results->geometry->location->lng;
   update_post_meta($post_id, '_geolocation_lat', $latitude);
   update_post_meta($post_id, '_geolocation_long', $longitude);
   $place_id=$results->geometry->place_id;
   update_post_meta($post_id, '_place_id', $place_id);
   $listeo_addon->log( $address_used . ' > latitude: ' . $latitude . ' / longitude: ' . $longitude );
  }
 }
}

function get_google_api_request_data($address, $key) {
 $request = wp_remote_get('https://maps.google.com/maps/api/geocode/json?address='.urlencode($address).
                          '&key='.urlencode($key).'&sensor=false');
 if (is_wp_error($request)) {
  $request = null;
 }
 return($request);
}

//add_action('pmxi_saved_post', 'pmxi_save_as_product', 10, 1);
function pmxi_save_as_product( $post_id){
		$post = get_post($post_id);
		if ($post->post_type == 'listing') {

			
			$product_id = get_post_meta($post_id, 'product_id', true);

			// basic listing informations will be added to listing
			$product = array (
				'post_author' => get_current_user_id(),
				'post_content' => $post->post_content,
				'post_status' => 'publish',
				'post_title' => $post->post_title,
				'post_parent' => '',
				'post_type' => 'product',
			);

			// add product if not exist
		if ( ! $product_id ||  get_post_type( $product_id ) != 'product') {
			
			// insert listing as WooCommerce product
			$product_id = wp_insert_post( $product );
			wp_set_object_terms( $product_id, 'listing_booking', 'product_type' );

		} else {

			// update existing product
			$product['ID'] = $product_id;
			wp_update_post ( $product );

		}

		
		// set product category
		$term = get_term_by( 'name', apply_filters( 'listeo_default_product_category', 'Listeo booking'), 'product_cat', ARRAY_A );

			if ( ! $term ) $term = wp_insert_term(
				apply_filters( 'listeo_default_product_category', 'Listeo booking'),
				'product_cat',
				array(
				  'description'=> __( 'Listings category', 'listeo-core' ),
				  'slug' => str_replace( ' ', '-', apply_filters( 'listeo_default_product_category', 'Listeo booking') )
				)
			  );
		  
			wp_set_object_terms( $product_id, $term['term_id'], 'product_cat');

			update_post_meta($post_id, 'product_id', $product_id);
		}
	
	}
